
import math, random


class PerlinNoise() :
    
    def __init__(self, seed) :
        
        self.random_size = 256
        self.values = [self.random_size*2]
        self.source = [self.random_size]
        random.seed(seed)

        
        for i in range(self.random_size) : 
            
            self.source[i] = random.randint(256)
            self.values[i] = self.source[i]
            self.values[i + random_size] = self.values[i]
        

    
    
    def lerp (self, t, a, b) :
        
        return a+ t * (b - a)
        
    def fade(self, t) :
        
        return t * t * t * (t * (t * 6 - 15) + 10)
        
    def grade(self, hash, x) :
        
        h = hash & 15
        if (h < 8) :
            u = x
        else : 
            u = y
            
        if h < 4 :
            v = y
        elif h == 12 or h ==14 :
            v = x
        else : 
            v = z
            
        if (h & 1) == 0 :
            u = u
        else : 
            u = -u
            
        if (h & 2) == 0 :
            v = v
        else : 
            v = -v
            
        return u + v
